﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraGridWithComboAndClassObjectHierarchy
{
    public partial class Form1 : Form
    {
        private List<MyClassA> MyDataList;
        public Form1()
        {
            InitializeComponent();
            MyDataList = new List<MyClassA>();
            ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 5; i++)
            {
                MyClassA objA = new MyClassA();
                objA.Id = i;
                objA.Property1 = "Value " + i.ToString();
                objA.Property2 = "Description " + i.ToString();

                for (int j = 0; j < 5; j++)
                {
                    MyClassB objB = new MyClassB();
                    objB.Id = (i * 10) + j;
                    objB.ParentId = i;
                    objB.Property = "Test item " + i.ToString() + " - " + j.ToString();
                    objA.Childs.Add(objB);
                }

                MyDataList.Add(objA);
            }
            ultraGrid1.DataSource = MyDataList;
            ultraGrid1.DisplayLayout.Bands[0].Columns["SelectedChild"].EditorComponent = ultraCombo1;
            
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (e.Row.Cells["SelectedChild"].Value != null)
            {
                e.Row.Cells["SelectedChild"].Activation = Infragistics.Win.UltraWinGrid.Activation.NoEdit;
            }
        }

        private void ultraGrid1_BeforeCellListDropDown(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {
            ultraCombo1.DataSource = MyDataList.SelectMany(p => p.Childs.Where(q => q.ParentId == (int)ultraGrid1.ActiveRow.Cells["Id"].Value)).ToList();
            ultraCombo1.DisplayMember = "Property";
            ultraCombo1.ValueMember = "Property";
        }

        private void ultraGrid1_AfterCellListCloseUp(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            ultraGrid1.ActiveRow.Cells["selectedChildId"].Value = ultraCombo1.SelectedRow.Cells["Id"].Value;
            ultraGrid1.ActiveRow.Cells["SelectedChildParentId"].Value = ultraCombo1.SelectedRow.Cells["ParentId"].Value;
        }
    }

    public class MyClassA
    {
        public MyClassA()
        {
            Childs = new List<MyClassB>();

        }

        private int id;

        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        private string property1;

        public string Property1
        {
            get { return property1; }
            set { property1 = value; }
        }
        private string property2;

        public string Property2
        {
            get { return property2; }
            set { property2 = value; }
        }

        private string selectedChild;

        public string SelectedChild
        {
            get { return selectedChild; }
            set { selectedChild = value; }
        }

        private string selectedChildId;

        public string SelectedChildId
        {
            get { return selectedChildId; }
            set { selectedChildId = value; }
        }

        private string selectedChildParentId;

        public string SelectedChildParentId
        {
            get { return selectedChildParentId; }
            set { selectedChildParentId = value; }
        }

        public List<MyClassB> Childs;
    }

    public class MyClassB
    {
        private int id;

        public int Id
        {
            get { return id; }
            set { id = value; }
        }

        private int parentId;

        public int ParentId
        {
            get { return parentId; }
            set { parentId = value; }
        }
        private string property;

        public string Property
        {
            get { return property; }
            set { property = value; }
        }
    }
}
